
#include "placa16f84.h"
#include "lcdbseta.c"


#byte puerto_a=0x05
#byte puerto_b=0x06
#byte TRISA=0x85
#byte TRISB=0x86
#byte TMR0=1
#byte OPTION_REG=0x81
#byte INTE=0x0B
#byte STATUS=3

 
unsigned char numero;
unsigned char numero2;
unsigned char numero3;
unsigned char contador;
unsigned char contador2;
unsigned char retardo;
unsigned char retardo2;



// Se pone para que no modifique el ensamblador
#OPT 0

void frecu3()
{

#asm 
  
      CLRF    contador
      CLRF    contador2
      BSF     STATUS    , 5      ;BANCO 1
      BCF     STATUS    , 5
      BCF     INTE    , 2
      CLRF    TMR0
      nop
      nop
      nop
      nop
BUCLEX03:               ;   Total 25uS
      nop               ;   1
      nop               ;   1      
                      //______TOTAL BUCLE 20 uS______
        movf   INTE,0       ;   1   1   1      12 CICLOS 12uS
        ANDLW   0x04        ;   1   1   1
        btfsc 3,2   ;skpnz  ;   1   2   2
        GOTO    SALTO13     ;   2   0   0
        MOVLW   0x01        ;   0   1   1
        ADDWF   contador,f  ;   0   1   1
        BTFSS 3,0  ; skpc   ;   0   1   2
        GOTO    SALTO03     ;   0   2   0
        INCF    contador2,f ;   0   0   1
        
SALTO03:
         BCF     INTE,2     ;   0   1   1
         GOTO    SALTO23    ;   0   2   2
SALTO13: 
        NOP               ;   1   0   0
        NOP               ;   1   0   0
        NOP               ;   1   0   0
        NOP               ;   1   0   0
        NOP               ;   1   0   0
        NOP               ;   1   0   0
        NOP               ;   1   0   0
SALTO23:  
        MOVLW   0x01         ;   1   1
        SUBWF   retardo, f   ;   1   1
        btfsc  3,0   ;skpnc  ;   1   2
        GOTO    SAL13        ;   2   0
//        nop
        DECF    retardo2, f  ;   0   1
SAL13:     
      MOVF    retardo,W   ;      1   1
      ADDWF   retardo2,W   ;     1   1
      btfsc 3,2   ;skpnz     ;   2   1
      btfsc 3,0   ;SKPNC     ;   1   2
      GOTO    BUCLEX03       ;   2   0
SALIR23:   
      MOVF    TMR0      , W
      MOVWF   numero
      
      
      MOVF    contador      , W
      MOVWF   numero2
      MOVF    contador2      , W
      MOVWF   numero3

#ENDASM

}



void main()
{
 char escala;
 char multipli;
 float xx;

     puerto_b=0;
     puerto_a=0;
   
   //Puerto B como salida
     TRISB=0x00;

   //Puerto A como entrada 
   TRISA=0xff;
   
   lcd_ini_seta();   
   lcd_cls();

   escala=3;

   while(true)
      {            
      if(bit_test(puerto_a,0)==1)
         {
            escala++;
            if(escala>3)escala=0;
            while(bit_test(puerto_a,0)==1);
         }
      lcd_gotoxy(2,1);   
      switch(escala)
             {
               case 0:
                  Lcd_putc ("1Mhz- 1S");
                  retardo=0x40;
                  retardo2=0x9c;
                  OPTION_REG=0xF8;
                  multipli=1;
                  break;
               case 1:
                  Lcd_putc ("1Mhz-.1S");
                  retardo=0xa0;
                  retardo2=0x0f;
                  OPTION_REG=0xF8;
                  multipli=10;
                  break;
               case 2:
                  Lcd_putc ("8Mhz    ");
                  retardo=0x00;
                  retardo2=0x7d;
                  OPTION_REG=0b11110010;
                  multipli=10;
                  break;
               case 3:
                  Lcd_putc ("32Mhz   ");
                  retardo=0x00;
                  retardo2=0x32;
                  OPTION_REG=0b11110100;
                  multipli=100;
                  break;                  
            }       
            
       lcd_gotoxy(16,1);
       lcd_putc("*");
       frecu3();
       lcd_gotoxy(16,1);
       lcd_putc(" ");
       
       xx=numero+numero2*256+numero3*65536;
       xx=xx*multipli;
       lcd_gotoxy(1,2);
       printf(lcd_putc,"%9.0f Hz",xx);
       delay_seta(25000);      
      }      
}


